com.smartgwt.client.types

## Enum EnumTranslateStrategy

- java.lang.Object
- - java.lang.Enum<EnumTranslateStrategy>
  - - com.smartgwt.client.types.EnumTranslateStrategy

- All Implemented Interfaces:
    ValueEnum, java.io.Serializable, java.lang.Comparable<EnumTranslateStrategy>

      public enum EnumTranslateStrategy
      extends java.lang.Enum<EnumTranslateStrategy>
      implements ValueEnum

  Determines how Java enums are translated to and from Javascript by the Smart GWT server.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `BEAN` Translates to/from a Javascript object containing one property for each property defined within the enum.
    `NAME` Translates to/from a String matching the constant name.
    `ORDINAL` Translates to/from an integer matching the ordinal number of the constant within the enumeration
    `STRING` Translates to/from a String matching the `enum.toString()`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getValue()`
    `static EnumTranslateStrategy` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static EnumTranslateStrategy[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### NAME

          public static final EnumTranslateStrategy NAME

      Translates to/from a String matching the constant name. This is the default if not set.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "name".

    - #### STRING

          public static final EnumTranslateStrategy STRING

      Translates to/from a String matching the `enum.toString()`.

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "string".

    - #### ORDINAL

          public static final EnumTranslateStrategy ORDINAL

      Translates to/from an integer matching the ordinal number of the constant within the enumeration

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "ordinal".

    - #### BEAN

          public static final EnumTranslateStrategy BEAN

      Translates to/from a Javascript object containing one property for each property defined within the enum. The constant itself and the ordinal number are included in the JS object. By default they are called "_constant" and "_ordinal", but this can be overridden with the `enumOrdinalProperty` and `enumConstantProperty` properties

      If this enumerated value is used in a `Component XML` file or server-side DataSource descriptor (.ds.xml file), use the value "bean".

  - ### Method Detail

    - #### values

          public static EnumTranslateStrategy[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (EnumTranslateStrategy c : EnumTranslateStrategy.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static EnumTranslateStrategy valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getValue

          public java.lang.String getValue()

      Specified by:
        `getValue` in interface `ValueEnum`